var Response, faker, lodash, urlParse;

faker = require('mars-deimos');

lodash = require('lodash');

urlParse = require('url').parse;

Response = (function() {
  function Response(fakeVars, fakerOptions1) {
    this.fakeVars = fakeVars;
    this.fakerOptions = fakerOptions1;
    this.fakers = {};
  }

  Response.prototype.trans = function(data, url, post) {
    this.post = post;
    this.get = urlParse(url, true).query;
    return this.walk(lodash.cloneDeep(data), [url]);
  };

  Response.prototype.getFaker = function(url) {
    if (!this.fakers[url]) {
      this.fakers[url] = faker(url, this.opt);
    }
    return this.fakers[url];
  };

  Response.prototype.walk = function(obj, url) {
    var i, j, k, len, v;
    switch (typeof obj) {
      case 'string':
        obj = this.getFaker(url.slice(0, url.length - 1).join('->')).fake(obj, Object.assign({}, this.fakeVars, {
          GET: this.get,
          POST: this.post
        }));
        break;
      case 'object':
        if (Array.isArray(obj)) {
          for (i = j = 0, len = obj.length; j < len; i = ++j) {
            v = obj[i];
            obj[i] = this.walk(v, url.concat(i));
          }
        } else {
          for (k in obj) {
            v = obj[k];
            obj[k] = this.walk(v, url.concat(k));
          }
        }
    }
    return obj;
  };

  return Response;

})();

module.exports = function(data, url, fakerOptions) {
  return new Response(data, url, fakerOptions);
};
